# Service account to run elastic search.
apiVersion: v1
kind: ServiceAccount
metadata:
  name: jobtech-taxonomy-highscore
---
# Service to expose and loadbalance between pods.
apiVersion: v1
kind: Service
metadata:
  name: jobtech-taxonomy-highscore
spec:
  selector:
    app: jobtech-taxonomy-highscore
  ports:
    - protocol: TCP
      port: 8000
      targetPort: 8000
---
# Deployment to create necessary pods with configurations.
apiVersion: apps/v1
kind: Deployment
metadata:
  name: jobtech-taxonomy-highscore
  labels:
    app: jobtech-taxonomy-highscore
spec:
  replicas: 2
  selector:
    matchLabels:
      app: jobtech-taxonomy-highscore
  template:
    metadata:
      labels:
        app: jobtech-taxonomy-highscore
    spec:
      # Pod to launch the service.
      serviceAccountName: jobtech-taxonomy-highscore
      securityContext:
          # Your app shall always run as nonroot.
          runAsNonRoot: true
      affinity:
        # Avoid to run many pods on same physical node. It increases reliability.
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 1
            podAffinityTerm:
              labelSelector:
                matchLabels:
                  app: jobtech-taxonomy-highscore
              topologyKey: kubernetes.io/hostname
      containers:
      - name: ann
        image: docker-images.jobtechdev.se/jobtech-taxonomy-highscore/jobtech-taxonomy-highscore:latest
        imagePullPolicy: Always
        volumeMounts:
        - name: tmp
          mountPath: /tmp 
        ports:
        - containerPort: 8000
        securityContext:
          readOnlyRootFilesystem: true
        resources:
          limits:
            memory: "1Gi"
          requests:
            memory: "500Mi"
      volumes:
      - name: tmp
        emptyDir: {}
